HDU 4496 D-City (并查集)

D-City

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 3052 Accepted Submission(s): 1082


Problem Description
Luxer is a really bad guy. He destroys everything he met.
One day Luxer went to D-city. D-city has N D-points and M D-lines. Each D-line connects exactly two D-points. Luxer will destroy all the D-lines. The mayor of D-city wants to know how many connected blocks of D-city left after Luxer destroying the first K D-lines in the input.
Two points are in the same connected blocks if and only if they connect to each other directly or indirectly.


Input
First line of the input contains two integers N and M.
Then following M lines each containing 2 space-separated integers u and v, which denotes an D-line.
Constraints:
0 < N <= 10000
0 < M <= 100000
0 <= u, v < N.


Output
Output M lines, the ith line is the answer after deleting the first i edges in the input.


Sample Input
5 10
0 1
1 2
1 3
1 4
0 2
2 3
0 4
0 3
3 4
2 4


Sample Output
1
1
1
2
2
2
2
3
4

5

Hint

The graph given in sample input is a complete graph, that each pair of vertex has an edge connecting them, so there's only 1 connected block at first. 
The first 3 lines of output are 1s  because  after  deleting  the  first  3  edges  of  the  graph,  all  vertexes  still  connected together. 
But after deleting the first 4 edges of the graph, vertex 1 will be disconnected with other vertex, and it became an independent connected block. 
Continue deleting edges the disconnected blocks increased and finally it will became the number of vertex, so the last output should always be N. 

题解:

这道题是说给你一些点和边,这些点是按照所给的方式连接的

 现在让你按照连接好的图,在按照这个顺序将边删除,观看每进行一次删除,模块数是多少?

通俗的讲就是有多少个集合?

如果按照正向思维当删除一个边时,模块数不一定会增加,因为还有其他的点连接着

现在按照逆向思维,倒着进行,刚开始是独立的N个模块,(并查集)每进行一次边的连接判断是不是在同一个集合

如果不在同一个集合,连接后,模块数减一,否则模块数不变。


代码:

///HDU 4496 D-city
///并查集的逆向思维
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>
#include <string>

using namespace std;

const int maxx=10005;
int par[maxx];
int coun[100005];

struct rod
{
    int u,v;
}s[100005];///M取值在100000;
///寻找根结点
int find(int x)
{
    if(par[x]!=x)
        return par[x]=find(par[x]);
    return par[x];
}
///集合合并
int unite(int x,int y)
{
    x=find(x);
    y=find(y);
    if(x!=y)
    {
        par[x]=y;
        return 1;
    }
    return 0;
}

int n,m;
int main()
{
    while(~scanf("%d %d",&n,&m))
    {
        for(int i=0;i<n;i++)
            par[i]=i;
            int ans=n;
    ///逆向输入
       for(int i=m-1;i>=0;i--)
       {
           scanf("%d %d",&s[i].u,&s[i].v);
       }
       
       for(int i=0;i<m;i++)
       {
            coun[m-i-1]=ans;///存放的是模块数

           if(unite(s[i].u,s[i].v))
           {
                  ans--;     ///如果两者之间可以建立边则模块减一
           }
       }

       for(int i=0;i<m;i++)
       {
           printf("%d\n",coun[i]);
       }

    }

    return 0;
}

代码2:

#include <iostream>
#include <cstdio>
#include <cstring>
#define M 100000+10
#define N 10000+10
using namespace std;
int n,m;

struct node
{
  int u,v;
} s[M];

int B[N],ans[M];

int fine(int x)
{
  if(B[x]!=x)
  B[x]=fine(B[x]);
  return B[x];
}
int main()
{
  int i;
  while(~scanf("%d%d",&n,&m))
  {
  memset(ans,0,sizeof(ans));
  memset(s,0,sizeof(s));
    for(i=0;i<n;i++)
    B[i]=i;
    for(i=0; i<m; i++)
    {
      scanf("%d%d",&s[i].u,&s[i].v);
    }
    int sum=n;
    for(i=m-1;i>=0;i--)
    {
      ans[i]=sum;
      int xx=fine(s[i].u);
      int yy=fine(s[i].v);
      if(xx!=yy)
      {
        sum--;
        B[xx]=yy;
      }
    }
    for(i=0;i<m;i++)
    printf("%d\n",ans[i]);
  }
  return 0;
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值